import random
from math import pow

class AbstractWars:
    def __init__(self):
        random.seed(123)

    # ----------------------------------------------
    def init(self, baseLocations, speed):
        self.B = len(baseLocations) / 2
        self.baseX = []
        self.baseY = []
        for i in range(self.B):
            self.baseX.append(baseLocations[2 * i])
            self.baseY.append(baseLocations[2 * i + 1])
        return 0

    # ----------------------------------------------
    # picks a random base to attack based on distance to the opponent bases: the closer the base, the higher the chances are
    def getRandomBase(self, sourceInd):
        probs = []
        sp = 0.0
        for i in range(len(self.others)):
            ind = self.others[i]
            probs.append(1 / (pow(self.baseX[sourceInd] - self.baseX[ind], 2) + pow(self.baseY[sourceInd] - self.baseY[ind], 2)))
            sp += probs[i]

        r = random.random() * sp
        s = 0.0

        for i in range(len(self.others)):
            s += probs[i]
            if s >= r:
                return self.others[i]
        return self.others[-1]

    # ----------------------------------------------
    def sendTroops(self, bases, troops):
        # compile the list of bases owned by other players
        self.others = []
        for i in range(self.B):
            if bases[2 * i] != 0:
                self.others.append(i)
        if not self.others:
            # noone to fight!
            return []

        att = []
        for i in range(self.B):
            if bases[2 * i] == 0 and bases[2 * i + 1] > 1000 * 2 / 3:
                # send troops to a random base of different ownership
                att.append(i)
                att.append(self.getRandomBase(i))
        return att

# -------8<------- end of solution submitted to the website -------8<-------

import sys

aw = AbstractWars()

N = int(raw_input())
baseLoc = []
for i in range(N):
    baseLoc.append(int(raw_input()))
S = int(raw_input())

retInit = aw.init(baseLoc, S)
print retInit
sys.stdout.flush()

for st in range(2000):
    B = int(raw_input())
    bases = []
    for i in range(B):
        bases.append(int(raw_input()))
    T = int(raw_input())
    troops = []
    for i in range(T):
        troops.append(int(raw_input()))

    ret = aw.sendTroops(bases, troops)
    print len(ret)
    for num in ret:
        print num
    sys.stdout.flush()
